PROGRAM Forest;   {Tab size = 2}
{A program to indicate the overall structure of a Pascal program. 
 AUTHOR      : Merlin L. Hanson
 VERSION     : 1.0             DATE  : 6/20/88
 COMPILED BY : Personal Pascal Version 2.00
}

  {$I GEMSUBS.PAS}
  CONST
    TAB      = 9;    ESC     =   27;
    NoBorder = 0;    MyBlack = $180;
  TYPE
    PathChars = PACKED ARRAY [1..80] OF char;
  VAR
    MyInFile      : {FILE OF} text;           {Pascal source file}
    CRT           : {FILE OF} text;           {OUTPUT file may be redirected}
    TextLine      : ARRAY [1..170] OF char;   {The crrent line}
    TextUpperCase : ARRAY [1..170] OF char;   {and its' equivalent}
    FileName      : Path_Name;                {Used for both files}
    Path          : Path_Name;                {Used for both files}
    NbrCharInLine : integer;                  {length of text line}
    ch            : char;                     {A general purpose character}
    LineNbr       : integer;                  {The line number, 1..n}
    Choice        : (Monitor,Printer,FileX);  {possible destinations}
    NbrTab        : integer;                  {Change each tab char to number tab spaces}
    PrinterModeChanged : boolean;             {Remember to reset the printer}
  {$I AUXSUBS.PAS (some of the VT-52 stuff is used)}
	    
  PROCEDURE DisplayExitBox;
    VAR  Box : dialog_ptr;  OK : integer;
    BEGIN
      Box := New_Dialog(2,  70,21,8,3);
      OK  := Add_DItem(Box,G_Button,
                       Selectable |Exit_Btn | Default,
                       2,1,4,1,   NoBorder,MyBlack);
      Set_DText(Box,OK,' OK ',System_Font,TE_Left);
      OK := Do_Dialog(Box,0);
      End_Dialog(Box);
      ClrScr;                 
    END {displayexitbox};
	        
	PROCEDURE SetUp;

    PROCEDURE DisplayCoverSheet;
      CONST
        w = 39;
        h = 16;
      VAR
        s   : ARRAY [1..12] OF string[35];
        Box : dialog_ptr;
        OK  : integer;

      PROCEDURE MakeText
                  (Box : dialog_ptr;
                     X : integer;
                     Y : integer;
                 NChar : integer;
                     S : string);
        VAR  junk : integer;
        BEGIN {maketext}
          junk := Add_DItem(Box,G_String,None,
                            X,Y,NChar,1,    NoBorder,MyBlack);
          Set_DText(Box,junk,S,System_Font,TE_Left);
        END {maketext};
  
      PROCEDURE DrawBox;
        VAR
          i, x, y : integer;
        BEGIN
        s[1] := '              FOREST     ';
        s[2] := '           Version 1.0   ';
        s[3] := '               by        ';
        s[4] := '         Merlin L. Hanson';
        s[5] := '          Genie Address: ';
        s[6] := '            M.L.HANSON   '; 
        s[7] := '                         ';
        s[8] := '                         ';
        s[9] := '  Portions of this product are';
        s[10] := 'Copyright  1986, 1987 OSS and CCD.';
        INSERT    (CHR(189),s[10],11           );
        s[11] := '   Used by Permission of OSS.';
        s[12] :=             ' OK ';
        Box := New_Dialog(12,    0,0,w,h);
        x := 3;  y := 1;
        FOR i := 1 TO 11 DO
          MakeText(Box,x,y + i, 34,    s[i]);
        OK := Add_DItem(Box,G_Button,
                  Selectable | Exit_Btn | Default,
                  17,14,4,1,     NoBorder,MyBlack);
        Set_DText(Box,OK,s[12],System_Font,TE_Left);
        END {drawbox};

      begin  {displaycoversheet}
        Clear_Screen;
        DrawBox;
        Center_Dialog(Box);
        OK := Do_Dialog(Box,0);
        End_Dialog(Box);
        Delete_Dialog(Box);
        Clear_Screen;
      END {displaycoversheet};
	
	  PROCEDURE OfferHelp;
	    VAR Choice : integer;
	    
	    PROCEDURE DisplayHelpScreen;
	      BEGIN 
	        Hide_Mouse;
          CRTExit; {reset the CRT}
          CRTInit; {automatic word wrap on.}
	        ClrScr;
                GoToXY(1,36);
	        WriteLn('FOREST.PRG');
	        GoToXY(2,35);
	        WriteLn('June 20,1988');
                GoToXY(3,14);
	        WriteLn('A program to show the structure of a Pascal program.');
                WriteLn; 
	        Write('The INPUT file should be a file that would be acceptible to a Pascal compiler,');
                WriteLn('  although it does not need a file extension of .PAS.');
                WriteLn;
	        Write('Text lines that declare PROCEDUREs, FUNCTIONs,');
	        Write(' Includes ( {$I, (*$I  ), and mostlines that have');
	        Write(' BEGIN followed by a comment will be displayed ');
                WriteLn('along with the    line number in the file.');
                WriteLn;
                WriteLn('Key words can be upper or lower case. The comment delimiter can be { or (*.');
                WriteLn;
	        WriteLn('The construct: ''BEGIN {\ comment}'' will NOT be printed.');
                WriteLn;
                Write('You will be asked for a tab setting.');
	        Write('  If your file doesn''t use tabs, the answer');
	        WriteLn(' must be a digit; but its'' value is immaterial.');         
	        Show_Mouse;
                DisplayExitBox;
                ClrScr;
	      END {displayhelpscreen};
	      
	    BEGIN {offerhelp}
	      Choice := Do_Alert(
	         '[2][  Do you want help?  ][ HELP | Who, ME? ]',2);
	      IF Choice = 1 THEN
	        DisplayHelpScreen;   
	    END {offerhelp};
	    
    PROCEDURE GetInputFile;
      BEGIN
        GoToXY(3,34);
        InverseVideo;
        WriteLn('  Input File ');
        NormVideo;
        Path := CONCAT('A:\*.*',CHR(0));
        FileName := CONCAT('________.PAS',CHR(0));
        IF Get_In_File(Path,FileName)
          THEN RESET(MyInFile,FileName)
          ELSE HALT; {user cancel}
        ClrScr;             
      END {getinputfile};

		PROCEDURE GetDestinationChoice;
      VAR
        Box            : dialog_ptr;
        Pushed         : Tree_Index;
        S              : string[20];
        Index, BoxText : integer;
        Item           : ARRAY [1..3] OF integer;
        ObjectFlag     : ARRAY [1..3] OF integer;
  
      procedure IdentifyTheButton;
        {returns with Pushed in the range 1..3}
        VAR i : integer;
          Find : boolean;
        BEGIN
          i := 1;
          Find := FALSE;
          REPEAT
            IF Item[i] = Pushed
              THEN Find := TRUE
              ELSE i    := i+1;
          UNTIL Find;
          Pushed := i;
        END {identifythebutton};
  
      BEGIN {getdestinationchoice};
        ClrScr;
        Box     := New_Dialog(5,0,0,40,14);
        BoxText := Add_DItem(Box,G_String,None,
                             5,3,40,1,
                             NoBorder,MyBlack);
        Set_DText(Box,BoxText,
                  'Where do you want the output?',
                  System_Font,TE_Center);
        ObjectFlag[1] := Radio_Btn|Selectable|Exit_Btn;
        ObjectFlag[2] := ObjectFlag[1] + Default;
        ObjectFlag[3] := ObjectFlag[1];
        FOR Index := 1 TO 3 DO
          BEGIN
            Item[Index] := Add_DItem(Box,G_Button,
                                     ObjectFlag[Index],
                                     5 + 11 * (Index - 1),7,    9,1,
                                     NoBorder,MyBlack);
            CASE Index OF
              1 : S := 'Monitor';
              2 : S := 'Printer';
              3 : S := 'File';
            END {case};
            Set_DText(Box,Item[Index],S,System_Font,TE_Center);
          END {do};
        Center_Dialog(Box);
        Pushed := Do_Dialog(Box,0);
        IdentifyTheButton;
        End_Dialog(Box);
        CASE Pushed OF
          1 : Choice := Monitor;
          2 : Choice := Printer;
          3 : Choice := FileX;
        END {case};
        ClrScr;
      END {getdestinationchoice};
  
    PROCEDURE DrawEmptyBox;
      VAR  Box : dialog_ptr;  
      BEGIN
        Box := New_Dialog(1,0,0,30,4);
        Center_Dialog(Box);
        Show_Dialog(Box,0);
        GoTOXY(13,32);
        Write(CRT,'Line Number:');
      END {drawemptybox};
      
      PROCEDURE GetTabSetting;
        LABEL 100;
        VAR
          Box : dialog_ptr;
          S   : str255;     
          junk,OK,TabN,Choice : integer;
        BEGIN
100:
          Hide_Mouse;
          Clear_Screen;
          Box := New_Dialog(3,0,0,30,7);
 {LINE 1}
          junk := Add_DItem(Box,G_Text,None,2,2,28,1,
                             NoBorder,MyBlack);
          Set_DText(Box,junk,'What is the Tab Size?',
                    System_font,TE_Center);
 {LINE 2}
          TabN := Add_DItem(Box,G_FText,
                            Editable,
                            15,3,   1,1,  NoBorder,MyBlack);                  
          Set_DEdit(Box,TabN,'_','9','2',System_Font,TE_Center);
 {LINE 3}
          OK := Add_DItem(Box,G_Button,
                            Default|Selectable|Exit_Btn,
                            13,5,  4,1,   NoBorder,MyBlack);
          Set_DText(Box,OK,' OK ', System_Font,TE_Center); 
                 
          Center_Dialog(Box);
          Show_Mouse;
          junk := Do_Dialog(Box,TabN);
          Get_DEdit(Box,TabN,S);
          {convert digit to Binary}
          NbrTab := ORD(S[1]) - 48;
          {GEM allows invalid exit, e.g., <Backspace> or <Esc>.
          Have to trap this case.}
          IF (NbrTab < 0) OR (NbrTab > 9) THEN
            GoTo 100;
       END {gettabsetting};
       
    PROCEDURE SetUpPrinter;
      VAR PrinterStatus, Choice : integer;

      function PtrStatus : integer;
        GEMDOS($11);

      BEGIN {setupprinter}
        PrinterStatus := PtrStatus;
        WHILE PrinterStatus = 0 DO
          BEGIN  
            Choice := Do_Alert(
             '[0][   Please turn the   |     printer on][ Abort | OK ]',2);
            PrinterStatus := PtrStatus;
            IF Choice = 1 THEN
              HALT;
          END;
        {Printer is ready to go.}  
        Choice := Do_Alert(
            '[2][Change pitch on Epson|    printer?][ Yes | No ]',2);
        IF Choice = 1 THEN 
          BEGIN   {\change the pitch} 
            {Note suppression on printing of above line by '\'}
            Choice := Do_Alert(
              '[0][ Characters per line ][ 80 | 132 | 160 ]',0);
            WriteLn(CHR(ESC),'@');               {reset printer}
            CASE Choice OF
              1 :                 ;              {Pica draft} 
              2 : WriteLn(CHR(15));              {compressed}
              3 : WriteLn(CHR(ESC),'M',CHR(15)); {compressed Elite}
            END {case};
            {Set form length to 11 inches.}
            WriteLn(CHR(ESC),'C',CHR(0),CHR(11));
            {Skip 6 line at the perforations.}
            WriteLn(CHR(ESC),'N',CHR(6));     
            PrinterModeChanged := TRUE;
          END {choice = 1};
      END {setupprinter};              

    BEGIN {setup}
      LineNbr := 0;
      PrinterModeChanged := FALSE;
      Init_Mouse;
      DisplayCoverSheet;
      OfferHelp;
      GetInputFile;
      GetTabSetting;  
      GetDestinationChoice;
      {Process the choice.}
      CASE Choice OF
        Monitor : BEGIN
                    Hide_Mouse;
                    ClrScr;
                  END;  
        Printer : BEGIN
                    Rewrite(OUTPUT,'PRN:');
                    SetUpPrinter;  
                  END;
        FileX   : BEGIN
                    GoToXY(3,35);
                    InverseVideo;
                    WriteLn(' Output File ');
                    NormVideo;
                    FileName := CONCAT('STRUCT  .TXT',CHR(0));
                    {Bad procedure name, actually getting an output file.}
                    IF Get_In_File(Path,FileName)
                      THEN Rewrite(OUTPUT,FileName)
                      ELSE HALT;
                    ClrScr;
                    REWRITE(CRT,'CON:');    
                    DrawEmptyBox;  {Will hold line numbers}
                  END;
      END {case};
    END {setup};

  PROCEDURE Compute;

    PROCEDURE GetLine;
      LABEL  100;
      VAR
        i, j : integer;    TextString : string[170];
        ch : char;    Done : boolean;
  
      FUNCTION UpperCase(ch : char) : char;
        BEGIN
          IF (ch >= 'a') AND (ch <= 'z')
            THEN UpperCase := CHR(ORD(ch) - 32{'a' - 'A'})
            ELSE UpperCase := ch;
        END {uppercase};
 
      PROCEDURE ChangeTabToSpaces;
        VAR  k : integer;
        BEGIN
          {NbrCharInLine will be used by the WriteLine procedure.} 
          NbrCharInLine := NbrCharInLine + (NbrTab - 1);
          FOR k := 1 TO NbrTab DO
            BEGIN
              TextLine[j] := ' ';
              TextUpperCase[j] := ' ';
              j := j + 1;
            END {do};             
        END {changetabtospaces};

         
      BEGIN {GetLine}
        Done := FALSE;
        REPEAT
          IF EOF(MyInFile) 
            THEN GoTo 100;
          ReadLn(MyInFile,TextString);
          IF LENGTH(TextString) = 0 
            THEN LineNbr := LineNbr + 1
            ELSE    Done := TRUE;
        UNTIL Done;
        NbrCharInLine := LENGTH(TextString);
        j := 1;  
        FOR i := 1 TO NbrCharInLine DO
          BEGIN
            IF TextString[i] = CHR(Tab)
              THEN ChangeTabToSpaces
              ELSE
                BEGIN
                  TextLine[j] := TextString[i];
                  TextUpperCase[j] := UpperCase(TextLine[j]);
                  j := j + 1;
                END; 
          END;
        LineNbr := LineNbr + 1;
100:
      END {getline};
  
    PROCEDURE AnalyzeLine;
      VAR  i : integer;
  
      PROCEDURE WriteLine;
        VAR  i : integer;  AllBlank : boolean;
    
        PROCEDURE PrintBar;
          BEGIN
            IF i MOD 2 <> 0
              THEN Write('|')
              ELSE Write(' ');
          END {printbar};
    
        PROCEDURE MeldStrings;
          VAR i, j : integer;
          BEGIN
            i := 1;
            WHILE TextLine[i] = ' ' DO
              BEGIN
                IF i MOD 2 = 0 THEN
                  TextLine[i] := '|';
                i := i + 1;
              END;
          END {meldstrings};
    
        BEGIN    {writeline}
          Write(LineNbr:5,' ');
          MeldStrings;
          FOR i := 1 TO NbrCharInLine DO
            Write(TextLine[i]);
          WriteLn;
        END {writeline};
    
      PROCEDURE AnalyzeFunction;
    
        PROCEDURE AnalyzeBEGIN;
          VAR  Find : boolean;
      
          PROCEDURE Analyze1Include;
      
            PROCEDURE Analyze2Include;
              BEGIN
                i := 1;
                WHILE TextLine[i] = ' ' DO
                  i := i + 1;
                IF  (TextUpperCase[i]     = '(') 
                AND (TextUpperCase[i + 1] = '*')
                AND (TextUpperCase[i + 2] = '$') 
                AND (TextUppercase[i + 3] = 'I')
                  THEN WriteLine;
                  {else return, last possibility}
              END {analyze2include};
      
            BEGIN {analyze1include}
              i := 1;
              WHILE TextLine[i] = ' ' DO
                i := i + 1;
              IF  (TextUpperCase[i]     = '{') 
              AND (TextUpperCase[i + 1] = '$') 
              AND (TextUpperCase[i + 2] = 'I')
                THEN WriteLine
                ELSE Analyze2Include;
            END {analyze1include};
      
          BEGIN {AnalyzeBegin}
            {Print BEGIN only if it is followed by a comment.
            If the first character is '\' (a la '$' usage),
            suppress printing that line.}
            Find := FALSE;
            i := 1;
            WHILE (TextLine[i] = ' ') AND (i < NbrCharInLine) DO
              i := i + 1;
            IF  (TextUpperCase[i  ] = 'B') 
            AND (TextUpperCase[i+1] = 'E')
            AND (TextUpperCase[i+2] = 'G')
              THEN
                BEGIN
                  REPEAT
                    i := i + 1;
                    IF ((TextLine[i] = '{') 
                    AND (TextLine[i + 1] <> '\'))
                              OR
                    ( 
                        (TextLine[i    ] =  '(') 
                    AND (TextLine[i + 1] =  '*')  
                    AND (TextLine[i + 2] <> '\')    )        
                      THEN Find := TRUE;
                  UNTIL Find OR (i = NbrCharInLine);
                END;
            IF Find
              THEN WriteLine
              ELSE Analyze1Include;
          END {analyzebegin};
      
        BEGIN (*analyzefunction*)
          i := 1;
          WHILE TextLine[i] = ' ' DO
            i := i + 1;
          IF (TextUpperCase[i]    = 'F') 
          AND (TextUpperCase[i+1] = 'U')
          AND (TextUpperCase[i+2] = 'N')
            THEN
              WriteLine
            ELSE
              AnalyzeBegin;
        END {Analyzefunction};
    
      BEGIN {analyzeline}
        {This is the first of several nested procedures which each check 
         for some particular syntax.  If they make a match, they print 
         the line.  If they fail to match they call a nested procedure
         which makes ITs' check, etc.  This outermost procedure detects
         PROGRAM and PROCEDURE declarations.} 
        i := 1;
        WHILE TextLine[i] = ' ' DO
          i := i + 1;
        IF  (TextUpperCase[i    ] = 'P')
        AND (TextUpperCase[i + 1] = 'R')
        AND (TextUpperCase[i + 2] = 'O')   
          THEN
            WriteLine
          ELSE
            AnalyzeFunction;
      END {analyzeline};
  
    PROCEDURE DisplayLineNbr;
      BEGIN
        IF Choice = FileX
          THEN
            BEGIN   (*\ Don't print this line.*)
              GoToXY(13,44);
              Write(CRT,LineNbr:5);
            END;
      END {displaylinenbr};
  
    BEGIN {compute}
      GetLine;
      WHILE NOT EOF(MyInFile) DO
        BEGIN
          AnalyzeLine;
          DisplayLineNbr;
          GetLine;
        END;
    END {compute};

  PROCEDURE CleanUp;
    BEGIN {cleanup}
      IF Choice = FileX THEN
        CLOSE(Output);
      Hide_Mouse;
      Init_Mouse;
      IF Choice = Monitor
        THEN
          DisplayExitBox;
      ClrScr;
      IF PrinterModeChanged THEN
        WriteLn(CHR(ESC),'@');        {reset the printer}
      {Next line logically shouldn't be needed; but mouse
      handling is a black art on the ST.}
      Show_Mouse;
    END {cleanup};

  BEGIN             {main}
    ClrScr;
    IF Init_Gem >= 0 THEN
      BEGIN
        NbrTab := 2;
        SetUp;
        Set_Mouse(M_Bee);
        Compute; 
        CleanUp;
        Exit_Gem;
      END {GEM block};
  END {program}.
(*                        Program Table of Contents  
    1 PROGRAM Forest;   {Tab size = 2}
    8  |{$I GEMSUBS.PAS}
   28  |{$I AUXSUBS.PAS (some of the VT-52 stuff is used)}
   30  |PROCEDURE DisplayExitBox;
   43  |PROCEDURE SetUp;
   45  | |PROCEDURE DisplayCoverSheet;
   54  | | |PROCEDURE MakeText
   61  | | | |BEGIN {maketext}
   67  | | |PROCEDURE DrawBox;
   94  | | |begin  {displaycoversheet}
  104  | |PROCEDURE OfferHelp;
  107  | | |PROCEDURE DisplayHelpScreen;
  138  | | |BEGIN {offerhelp}
  145  | |PROCEDURE GetInputFile;
  159  | |PROCEDURE GetDestinationChoice;
  168  | | |procedure IdentifyTheButton;
  183  | | |BEGIN {getdestinationchoice};
  220  | |PROCEDURE DrawEmptyBox;
  230  | | |PROCEDURE GetTabSetting;
  269  | |PROCEDURE SetUpPrinter;
  272  | | |function PtrStatus : integer;
  275  | | |BEGIN {setupprinter}
  307  | |BEGIN {setup}
  343  |PROCEDURE Compute;
  345  | |PROCEDURE GetLine;
  351  | | |FUNCTION UpperCase(ch : char) : char;
  358  | | |PROCEDURE ChangeTabToSpaces;
  372  | | |BEGIN {GetLine}
  399  | |PROCEDURE AnalyzeLine;
  402  | | |PROCEDURE WriteLine;
  405  | | | |PROCEDURE PrintBar;
  412  | | | |PROCEDURE MeldStrings;
  424  | | | |BEGIN    {writeline}
  432  | | |PROCEDURE AnalyzeFunction;
  434  | | | |PROCEDURE AnalyzeBEGIN;
  437  | | | | |PROCEDURE Analyze1Include;
  439  | | | | | |PROCEDURE Analyze2Include;
  452  | | | | | |BEGIN {analyze1include}
  463  | | | | |BEGIN {AnalyzeBegin}
  493  | | | |BEGIN (*analyzefunction*)
  506  | | |BEGIN {analyzeline}
  511  | | | | PROGRAM and PROCEDURE declarations.} 
  524  | |PROCEDURE DisplayLineNbr;
  534  | |BEGIN {compute}
  544  |PROCEDURE CleanUp;
  545  | |BEGIN {cleanup}
  561  |BEGIN             {main}

*)
